<?php declare(strict_types=1);
// Autor (c) Miroslav Novak, www.platiti.cz
// Pouzivani bez souhlasu autora neni povoleno
// #Ver:PRV108-60-g39033a71:2024-08-14#


namespace Platiti\UniAdapter\Storefront\Controller;

use Platiti\PtiUniNs\UniModul\UniErr;
use Platiti\UniAdapter\Service\UniPaymentAdapter;
use Shopware\Core\System\SalesChannel\SalesChannelContext;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Response;
use Shopware\Storefront\Controller\StorefrontController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Shopware\Core\Framework\Log\Package;

use Symfony\Component\HttpFoundation\Request;
#[Package('checkout')]
#[Route(defaults: ['_routeScope' => ['storefront']])]
class UniPaymentController extends StorefrontController
{

	protected $adapter;
	public function __construct(UniPaymentAdapter $adapter) {
		$this->adapter = $adapter;
	}

	#[Route(path: '/UniPaymentReply', name: 'frontend.uniadapter.reply', methods: ['POST', 'GET'], defaults: ['csrf_protected' => false])]
	public function reply(Request $request, SalesChannelContext $context): Response
	{
		return UniErr::run(null, function() use ($request, $context) {
			$url = $this->adapter->receiveReply($request, $context);
			return new RedirectResponse($url);
		});
	}

}
